/*
$Id: fglExt.h,v 1.1.1.1 1998/07/21 10:27:53 rene Exp $
*/
#ifndef FGLEXT_H
#define FGLEXT_H
#include <f2c/f2cRts0.h>

typedef int(*FunctionC)(int);
typedef struct UsrFunction{
  const char* ident;
  /*FunctionC function;*/
  int(*function)(int);
  int nPar;
  int nRet;
}UsrFunction;

typedef struct UsrData{
  const char* ident;
  Field *field;
}UsrData;


#define GLOB_CHAR(n,s)    char  C_##n[s+1]; static const FieldType T_##n={T_fChar,sizeof(C_##n)};  static Field n={   C_##n, &T_##n }
#define GLOB_VARCHAR(n,s) char  C_##n[s+1]; static const FieldType T_##n={T_vChar,sizeof(C_##n)};  static Field n={   C_##n, &T_##n }
#define GLOB_SMALLINT(n)  short C_##n;      static const FieldType T_##n={T_short,sizeof(C_##n)};  static Field n={ & C_##n, &T_##n }
#define GLOB_INT(n)       long  C_##n;      static const FieldType T_##n={T_long,sizeof(C_##n)};   static Field n={ & C_##n, &T_##n }
#define GLOB_SMALLFLOAT(n)float C_##n;      static const FieldType T_##n={T_float,sizeof(C_##n)};  static Field n={ & C_##n, &T_##n }
#define GLOB_FLOAT(n)     double C_##n;     static const FieldType T_##n={T_double,sizeof(C_##n)}; static Field n={ & C_##n, &T_##n }
#define GLOB_DATE(n)      long  C_##n;      static const FieldType T_##n={T_Date,sizeof(C_##n)};   static Field n={ & C_##n, &T_##n }
#define GLOB_DECIMAL(n,sig,rd)   dec_t C_##n;   static const FieldType T_##n={T_decimal,sizeof(dec_t), PRECMAKE(sig,rd)};   static Field n={ & C_##n, &T_##n }
#define GLOB_MONEY(n,sig,rd)   dec_t C_##n;   static const FieldType T_##n={T_money,sizeof(dec_t), PRECMAKE(sig,rd)};   static Field n={ & C_##n, &T_##n }

#define GLOB(n) { #n, &n }

extern UsrFunction usrFunctions[];
extern UsrData usrData[];

#include <f2c/r_c.h>

#endif
